<SCRIPT>
   /*
    *  Dynamic Buttons JavaScript, (C) Morten Moeller/Lombardi Software 2001.
    *
    *
    *  PUBLIC FUNCTIONS AT THE END OF THE SCRIPT
    */

   var   btnUrl="/teamworks/tm_button";
   var   pageButtons = new Array();
   var   buttonWidth = 120;

   // type : 0 - Normal, 1 - Highlite
   function ImageUrl(btn, type) {
      var txtCol = 0;
      var bgCol = 0;
      var down = 0;

      if (type == 0) {
         txtCol = stdTXTColor;
         bgCol = stdBGColor;
      }

      if (type == 1) {
         txtCol = hiTXTColor;
         bgCol = hiBGColor; 
      }

      if (btn.disabled == 1) {
         txtCol = disabledTXTColor 
         bgCol = disabledBGColor 
      }

      return btnUrl + "?lineH=23&text=" + btn.text + "&width=" + btn.width + "&down=" + btn.down + "&lines=" + btn.length + "&bgColor=" + bgCol+ "&textColor=" + txtCol;

   }

   function getButton(name) {
      var found = false;
      for(i = 0; i < pageButtons.length; i++) {
          if (name == pageButtons[i].name) {
	     return pageButtons[i];	  
          }
      }
   }


   function buttonImages(name, text, isDisabled, length, width) {
      this.name = name;
      this.disabled = isDisabled;
      this.img = 0;
      this.length = length;
      this.text = text;
      this.down = 0;
      this.width = width;
   }

   function mouseDown(name) {
      btn = getButton(name);
      if (btn.disabled == 0) {
         btn.down = 1;
         btn.img.src = ImageUrl(btn,1);

      }
   }
   function mouseUp(name) {
      btn = getButton(name);
      if (btn.disabled == 0) {
         btn.down = 0;
         btn.img.src = ImageUrl(btn,1);
      }
   }


   function mouseOver(name) {
      btn = getButton(name);
      if (btn.disabled == 0) {

         btn.img.src = ImageUrl(btn, 1);

      }

   }

   function mouseOut(name) {
      btn = getButton(name);
      if (btn.disabled == 0) {
         btn.down = 0;
         btn.img.src = ImageUrl(btn, 0);
      }
   }

   function switchDisable(name) {
      if (isDisabled(name)) {
          enableButton(name);
      } else {
          disableButton(name); 
      }
   }


   /* ================================================================
    * PUBLIC FUNCTIONS
    * ================================================================
    */

  //
  // FUNC: addButton(name, text, isDisabled, lines, href)
  // DESC: Adds a button to the page. name is an internal name and has to
  //       be unique on the page. Text is the text on the button. isDisabled
  //       should be 1 if the button is disabled, and 0 if not. lines is 
  //       the number of lines allowed on the button. Href is the link.
  //
  // 
  function addButton(name, text, isDisabled, lines, href, width) {
      var btn = new buttonImages(name, text, isDisabled, lines, width);

      if (href == 0) {
          href = "nohref";
      } else {
          href = "href='" + href + "'";
      }

      document.write("<A " + href + " onMouseDown='mouseDown(\"" + name + "\")' onMouseUp='mouseUp(\"" + name + "\")' onMouseOut='mouseOut(\"" + name + "\")' onMouseOver='mouseOver(\"" + name + "\")'>");

      document.write("<IMG BORDER=0 WIDTH=" + btn.width + " HEIGHT=" + (lines*23) + " NAME='twbtn-" + name +"' SRC='" + ImageUrl(btn, isDisabled * 2) + "'>");
      document.write("</A>");
      // Must check for NS4 later
      btn.img = document.all["twbtn-" + name];

      pageButtons[pageButtons.length] = btn;
      return pageButtons[pageButtons.length-1];     
   }

   // 
   // FUNC: disableButton(name) 
   // DESC: Disables a button
   //
   function disableButton(name) {
      btn = getButton(name);
      btn.disabled = 1;
      btn.img.src = ImageUrl(btn, 0);
       
   }

   // 
   // FUNC: enableButton(name) 
   // DESC: Enables a button
   //
   function enableButton(name) {
      btn = getButton(name);
      btn.disabled = 0;
      btn.img.src = ImageUrl(btn, 0);
   }

   // 
   // FUNC: isDisabled(name)
   // DESC: Returns 1 if button is disabled, 0 if not
   //
   function isDisabled(name) {
      btn = getButton(name);
      return btn.disabled;      
   }
</SCRIPT>
