<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="java.math.BigDecimal,
                 com.lombardisoftware.servlet.util.*,
                 java.util.*,
                 java.text.SimpleDateFormat,
                 com.lombardisoftware.core.StringUtilities,
                 com.lombardisoftware.client.DateFormatUtils,
                 com.lombardisoftware.client.persistence.UnderCoverAgentBlackout,
                 com.lombardisoftware.client.persistence.common.versioning.*,
                 com.lombardisoftware.client.persistence.UnderCoverAgentBlackoutFactory" %>
<%@ page import="com.lombardisoftware.client.persistence.common.ID"%>
<%@ page import="com.lombardisoftware.servlet.SetUserTimeZoneFilter"%>
<%@ page import="com.lombardisoftware.utility.i18n.LocaleUtils" %>
<%@ page import="com.ibm.icu.util.TimeZone"%>
<%@ include file="common/prolog.jsp" %>
<%@ include file="/html/msgs-init.jsp" %>
<%
    // Norwegian in "no" in Java but "nb" in Dojo.
    String language = ((Locale) session.getAttribute(Globals.LOCALE_KEY)).toString();
    if (language.equals("no")) {
        language = "nb";
    }else{
        language = language.toLowerCase().replace('_', '-');
    }
    
    if( !LocaleUtils.isLocaleSupportedInHeritageUIs((Locale) session.getAttribute(Globals.LOCALE_KEY)) ){
    	language = LocaleUtils.FALLBACK_LOCALE.toString();
    }
%>
<html>
<head>
<title><bean:message key="cs_blackout.title" /></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="<lsw:ContextRoot zWebAppName='<%=com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_PROCESSPORTALSUPPORT%>'/>/js/dojo/1.6.1/dijit/themes/soria/soria.css">
<script type="text/javascript" src="<lsw:ContextRoot zWebAppName='<%=com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_PROCESSPORTALSUPPORT%>'/>/js/dojo/1.6.1/dojo/dojo.js"
        djConfig="parseOnLoad:true, locale:'<%= language%>'"></script>
<script src="<lsw:ImagePrefix/>script/validation.js" type="text/javascript"></script>
<script type="text/javascript">
    dojo.require("dijit.form.DateTextBox");
    dojo.require("dojo.date.locale");

    dojo.addOnLoad(function(){

        // Setup calendar drop-down style.
        dojo.addClass(dojo.body(), "soria");

        // Copy dates from widgets to JSP fields.
        zDateFromWidget.onChange = function(){
            dojo.byId("zDateFrom").value = dateToString(zDateFromWidget.getValue());
        };

        zDateToWidget.onChange = function(){
            dojo.byId("zDateTo").value = dateToString(zDateToWidget.getValue());
        };
        
        <% if (request.getParameter("zMessage") == null) { %>
            doClean();  
        <% } else {%>        
            var actionString = "<%= request.getParameter("zAction") %>"; 
            var zBlackoutId = document.frm.zBlackoutId.value;   
            if (actionString == "update") {
                document.frm.addB.disabled = true;
                document.frm.deleteB.disabled = false;
                document.frm.newB.disabled = false;
                document.frm.updateB.disabled = false;
                setupCombo(document.frm.BlackoutList, zBlackoutId);
            } else if (actionString == "add") {
                document.frm.addB.disabled = false;
                document.frm.deleteB.disabled = true;
                document.frm.newB.disabled = false;
                document.frm.updateB.disabled = true;
            }
            setupCombo(document.frm.zWeekdayFrom, "<%= request.getParameter("zWeekdayFrom") %>");
            setupCombo(document.frm.zWeekdayTo, "<%= request.getParameter("zWeekdayTo") %>");
            doRadio("<%= request.getParameter("zRangeType") %>");
        <% }%>
        dojo.byId("zDateFormatPattern").innerHTML = "(" + dojo.cldr.nls.gregorian[dojo.locale.replace('-', '_')]['dateFormat-short'] + ")";
    });

    function /*Date*/ parseDate(/*String*/ stringDate) {
        if (stringDate == null || stringDate == "") return null;
        return dojo.date.locale.parse(stringDate, {datePattern: "MM/dd/yyyy", selector: "date"});
    }

    function /*String*/ dateToString(/*Date*/ date) {
        if (date == null || date == "") return null;
        return dojo.date.locale.format(date, {datePattern: "MM/dd/yyyy", selector: "date"});
    }    
    
</script>

<script type="text/javascript" language="JavaScript">

var dispWeekDays = {
  "Mon": "<bean:message key="cs_blackout.label.weekday_Monday" />",
  "Tue": "<bean:message key="cs_blackout.label.weekday_Tuesday" />",
  "Wed": "<bean:message key="cs_blackout.label.weekday_Wednesday" />",
  "Thu": "<bean:message key="cs_blackout.label.weekday_Thursday" />",
  "Fri": "<bean:message key="cs_blackout.label.weekday_Friday" />",
  "Sat": "<bean:message key="cs_blackout.label.weekday_Saturday" />",
  "Sun": "<bean:message key="cs_blackout.label.weekday_Sunday" />"
}

var arrayAll = new Array();

function ListEntry(id, type, dateFrom, dispDateFrom, timeFrom, dateTo, dispDateTo, timeTo, weekdayFrom, weekdayTimeFrom, weekdayTo, weekdayTimeTo) {

  this.id = id;
  this.type = type;
  this.dateFrom = dateFrom;
  this.dispDateFrom = dispDateFrom;
  this.timeFrom = timeFrom;
  this.dateTo = dateTo;
  this.dispDateTo = dispDateTo;
  this.timeTo = timeTo;
  this.weekdayFrom = weekdayFrom;
  this.weekdayTimeFrom = weekdayTimeFrom;
  this.weekdayTo = weekdayTo;
  this.weekdayTimeTo = weekdayTimeTo;
}

function compareEntry(a, b) {
  var na = "";
  if (a.description)
     na = a.description.toLowerCase();
  var nb = "";
  if (b.description)
     nb = b.description.toLowerCase();
  if (na < nb)
    return -1;
  else if (na > nb)
    return 1
  else
    return 0;
}

<%
 SimpleDateFormat dfDate = new SimpleDateFormat("MM/dd/yyyy", Locale.ENGLISH);
 SimpleDateFormat dfTime = new SimpleDateFormat("HH:mm", Locale.ENGLISH);
 SimpleDateFormat dfDay = new SimpleDateFormat("E", Locale.ENGLISH);
 SimpleDateFormat dfDayTime = new SimpleDateFormat("HH:mm", Locale.ENGLISH);
 com.ibm.icu.text.DateFormat dispDfDate = DateFormatUtils.getDateFormat(DateFormatUtils.MEDIUM);
 TimeZone userTimeZone = (TimeZone)session.getAttribute(SetUserTimeZoneFilter.SESSION_USER_TZ_KEY);
 java.util.TimeZone jdkTimeZone = java.util.TimeZone.getTimeZone(userTimeZone.getID());
 dfDate.setTimeZone(jdkTimeZone);
 dfTime.setTimeZone(jdkTimeZone);
 dispDfDate.setTimeZone(userTimeZone);
 Collection blackouts = UnderCoverAgentBlackoutFactory.getInstance().findAll();
 for (Iterator it = blackouts.iterator() ;it.hasNext();) { 
   UnderCoverAgentBlackout bo = (UnderCoverAgentBlackout)it.next();
   if (bo.getDateType().equals("S")) {
     try {
       String dateFrom = dfDate.format(bo.getFromDatetime());
       String dispDateFrom = dispDfDate.format(bo.getFromDatetime());
       String timeFrom = dfTime.format(bo.getFromDatetime());
       String dateTo = dfDate.format(bo.getToDatetime());
       String dispDateTo = dispDfDate.format(bo.getToDatetime());
       String timeTo = dfTime.format(bo.getToDatetime());
%>
arrayAll[arrayAll.length] = new ListEntry("<%= ID.toExternalString(bo.getBlackoutId()) %>", "<%= bo.getDateType() %>",
					  "<%= dateFrom %>", "<%= dispDateFrom %>", "<%= timeFrom %>", "<%= dateTo %>", "<%= dispDateTo %>", "<%= timeTo %>",
					  "", "", "", ""
					  );
<%
     } catch (Exception e) {}
   } else if (bo.getDateType().equals("D")) {
     try {
       String weekdayFrom = dfDay.format(bo.getFromDatetime());
       String weekdayTimeFrom = dfDayTime.format(bo.getFromDatetime());
       String weekdayTo = dfDay.format(bo.getToDatetime());
       String weekdayTimeTo = dfDayTime.format(bo.getToDatetime());
%>
arrayAll[arrayAll.length] = new ListEntry("<%= ID.toExternalString(bo.getBlackoutId()) %>", "<%= bo.getDateType() %>",
					  "", "", "", "", "", "",
					  "<%= weekdayFrom %>", "<%= weekdayTimeFrom %>", "<%= weekdayTo %>", "<%= weekdayTimeTo %>"
					  );
<%
     } catch (Exception e) {}
   }
 }
%>

arrayAll = arrayAll.sort(compareEntry);

function doFillDetails(obj) {

  var id = 0;
   if (obj != null) {
    id = obj.options[obj.selectedIndex].value;;
  }
  for(i = 0; i < arrayAll.length; i++) {
    var blackout = arrayAll[i];
    if (blackout.id == id) {
      document.frm.zBlackoutId.value = blackout.id;
      document.frm.zDateFrom.value = blackout.dateFrom;
      zDateFromWidget.setValue(parseDate(blackout.dateFrom));
      document.frm.zTimeFrom.value = blackout.timeFrom;
      document.frm.zDateTo.value = blackout.dateTo;
      zDateToWidget.setValue(parseDate(blackout.dateTo));
      document.frm.zTimeTo.value = blackout.timeTo;
      document.frm.zWeekdayFrom.value = blackout.weekdayFrom;
      document.frm.zWeekdayTimeFrom.value = blackout.weekdayTimeFrom;
      document.frm.zWeekdayTo.value = blackout.weekdayTo;
      document.frm.zWeekdayTimeTo.value = blackout.weekdayTimeTo;
      if (blackout.type == "S")
        doRadio("datetime");
      else
        doRadio("weekdaytime");
      document.getElementById('error').style.visibility = "hidden";
      document.frm.addB.disabled = true;
      document.frm.deleteB.disabled = false;
      document.frm.newB.disabled = false;
      document.frm.updateB.disabled = false;
      return;
    }
  }
}

function doAdd() {
  document.frm.zAction.value = 'add';
  if (vldForm(document.frm)) {
	var fromDate = new Date(document.frm.zDateFrom.value + " " + document.frm.zTimeFrom.value);
	var toDate = new Date(document.frm.zDateTo.value + " " + document.frm.zTimeTo.value); 
	if ((fromDate > toDate) && (document.frm.zRangeType[0].checked == true)) {
	  alert("<bean:message key="cs_blackout.date.validate"/>");
	  return false; 
    }
  } else {
      return vldForm(document.frm);
  }
}

function doDelete() {
  if (confirm('<bean:message key="cs_blackout.doDelete.confirm" />')){
    document.frm.zAction.value = 'delete';
    return true;
  } else {
    return false;
  }
}

function doUpdate() {
  document.frm.zAction.value = 'update';
  if (vldForm(document.frm)) {
	var fromDate = new Date(document.frm.zDateFrom.value + " " + document.frm.zTimeFrom.value);
	var toDate = new Date(document.frm.zDateTo.value + " " + document.frm.zTimeTo.value); 
	if ((fromDate > toDate) && (document.frm.zRangeType[0].checked == true)) {
	  alert("<bean:message key="cs_blackout.date.validate"/>");
	  return false; 
    }
  } else {
      return vldForm(document.frm);
  }
}

function doClear() {
  document.getElementById('error').style.visibility = "hidden";
  doClean();
}

function doClean() {
  document.frm.zBlackoutId.value = "";
  document.frm.zDateFrom.value = "";
  document.frm.zTimeFrom.value = "";
  document.frm.zDateTo.value = "";
  document.frm.zTimeTo.value = "";
  document.frm.zWeekdayFrom.selectedIndex = -1;
  document.frm.zWeekdayTimeFrom.value = "";
  document.frm.zWeekdayTo.selectedIndex = -1;
  document.frm.zWeekdayTimeTo.value = "";
  document.frm.addB.disabled = false;
  document.frm.deleteB.disabled = true;
  document.frm.newB.disabled = false;
  document.frm.updateB.disabled = true;
  document.frm.BlackoutList.selectedIndex = -1;
  document.frm.zRangeType[0].checked = true;

  zDateFromWidget.reset();
  zDateToWidget.reset();

  doRadio("datetime");
}

function doRadio(value) {
  if (value == "datetime") {
    disableWeekdaytime();
    enableDatetime();
    document.frm.zRangeType[0].checked = true;
  } else {
    disableDatetime();
    enableWeekdaytime();
    document.frm.zRangeType[1].checked = true;
  }
}

function disableDatetime() {
  document.frm.zDateFrom.disabled = true;
  document.frm.zTimeFrom.disabled = true;
  document.frm.zDateTo.disabled = true;
  document.frm.zTimeTo.disabled = true;
  zDateFromWidget.setDisabled(true);
  zDateToWidget.setDisabled(true);
}

function enableDatetime() {
  document.frm.zDateFrom.disabled = false;
  document.frm.zTimeFrom.disabled = false;
  document.frm.zDateTo.disabled = false;
  document.frm.zTimeTo.disabled = false;
  zDateFromWidget.setDisabled(false);
  zDateToWidget.setDisabled(false);
}

function disableWeekdaytime() {
  document.frm.zWeekdayFrom.disabled = true;
  document.frm.zWeekdayTimeFrom.disabled = true;
  document.frm.zWeekdayTo.disabled = true;
  document.frm.zWeekdayTimeTo.disabled = true;
}

function enableWeekdaytime() {
  document.frm.zWeekdayFrom.disabled = false;
  document.frm.zWeekdayTimeFrom.disabled = false;
  document.frm.zWeekdayTo.disabled = false;
  document.frm.zWeekdayTimeTo.disabled = false;
}

function setupCombo(obj, value) {
 obj.selectedIndex = -1;
 for(i = 0; i < obj.options.length; i++) {
   if (obj.options[i].value == value) {
     obj.options[i].selected = true;
     break;
   }
 }
}

//-->
</script>
</head>

<link rel="stylesheet" href="./html/common/tw_console.css" type="text/css" />
<body class="cswelcomebody">
<table width="100%" valign="top" cellpadding="2" cellspacing="0" border="0" style="margin-top:0px">
<tr>
  <td id="content">
  <div class="heading"><h1><bean:message key="cs_blackout.title" /></h1></div>
  </td>
</tr>
<tr>
<td>

<form name="frm" method="post" action="cs_blackout.lsw">
<input type="hidden" name="zBlackoutId" value="<%= request.getParameter("zBlackoutId") %>"/>
<input type="hidden" name="zObject" value="Blackout"/>
<input type="hidden" name="zActivity" value="Change"/>
<input type="hidden" name="zPost" value="1"/>
<input type="hidden" name="zAction" value="add"/>
<table style="margin:5" cellpadding="2" cellspacing="0" border="0">
<tr>
<td valign="top">
 <div class="cslabel">&nbsp;<bean:message key="cs_blackout.label.text" /><br/></div>
 <select size="17" style="width:260" name="BlackoutList" onChange="return doFillDetails(this);">
<script type="text/javascript" language="JavaScript">
 var zBlackoutId = "<%= request.getParameter("zBlackoutId")%>";
 if (arrayAll != null) {
   for(i = 0; i < arrayAll.length; i++) {
     document.write("<OPTION VALUE='" + arrayAll[i].id +"'");
     if (arrayAll[i].id == zBlackoutId)
       document.write(" SELECTED");
     document.write(">");
     if (arrayAll[i].type == "S")
       document.write(arrayAll[i].dispDateFrom+" "+arrayAll[i].timeFrom+"-"+arrayAll[i].dispDateTo+" "+arrayAll[i].timeTo);
     else
       document.write(dispWeekDays[arrayAll[i].weekdayFrom]+" "+arrayAll[i].weekdayTimeFrom+"-"+dispWeekDays[arrayAll[i].weekdayTo]+" "+arrayAll[i].weekdayTimeTo);
     document.write("</OPTION>\n");
   }
 }
 </script>
 </select>
 <br/>
</td>
<td valign="top">
  <div class="cslabel">&nbsp;&nbsp;<bean:message key="cs_blackout.label.details.text" /></div>
  
<table cellpadding="2" cellspacing="0" border="0" class="content-table" style="border:solid gray 1px;margin:5px">
<tr>
 <td valign="middle">
   <input type="radio" name="zRangeType" value="datetime" onClick="doRadio(this.value)" checked="true"/>
 </td>
 <td>

 <div class="lbl"><bean:message key="cs_blackout.label.dateTime.text" /></div>

<table cellpadding="2" cellspacing="0" border="0" class="content-table" style="border:solid gray 0px;margin:5px">
<tr>
</tr>
<tr>
<td>&nbsp;</td>
<td align="left">
  <div class="lbl"><bean:message key="cs_blackout.label.from.text" /></div>
</td>
<td>
  <input dojoType="dijit.form.DateTextBox" jsId="zDateFromWidget" style="width:8em"/>
  <input type="hidden" id="zDateFrom" name="zDateFrom" value="<%= (request.getParameter("zDateFrom") == null ? "" : request.getParameter("zDateFrom")) %>" />
  &nbsp;<input class="dijitTextBox" type="text" name="zTimeFrom" value="<%= (request.getParameter("zTimeFrom") == null ? "" : request.getParameter("zTimeFrom")) %>" style="width:7em" maxlength="8"/>
</td>
<td></td>
</tr>
<tr>
<td>&nbsp;</td>
<td align="left">
  <div class="lbl"><bean:message key="cs_blackout.label.to.text" /></div>
</td>
<td>
  <input dojoType="dijit.form.DateTextBox" jsId="zDateToWidget" style="width:8em"/>
  <input type="hidden" id="zDateTo" name="zDateTo" value="<%= (request.getParameter("zDateTo") == null ? "" : request.getParameter("zDateTo")) %>"/>
  &nbsp;<input class="dijitTextBox" type="text" name="zTimeTo" value="<%= (request.getParameter("zTimeTo") == null ? "" : request.getParameter("zTimeTo")) %>" style="width:7em" maxlength="8"/>
  </td>
  <td></td>
</tr>
<tr>
  <td colspan="2">&nbsp;&nbsp;&nbsp;</td>
  <td>
    <div class="lbl"><i id="zDateFormatPattern"></i>&nbsp;&nbsp;<i><bean:message key="cs_blackout.label.timeFormat.text" /></i></div>
  </td>
  <td>
  </td>
</tr>
</table>

</td>
</tr>

<tr>
  <td valign="middle">
    <input type="radio" name="zRangeType" value="weekdaytime" onClick="doRadio(this.value)"/>
  </td>
  <td>
   <div class="lbl"><bean:message key="cs_blackout.label.weekdayTime_Range" /></div>
   <table cellpadding="2" cellspacing="0" border="0" class="content-table"  style="border:solid gray 1px;margin:5px">

   <tr>
   </tr>
   <tr>
   <td>&nbsp;</td>
   <td align="left">
     <div class="lbl"><bean:message key="cs_blackout.label.from.text" /></div>
   </td>
   <td>
   <select name="zWeekdayFrom">
    <option value="Mon"><bean:message key="cs_blackout.label.weekday_Monday" /></option>
    <option value="Tue"><bean:message key="cs_blackout.label.weekday_Tuesday" /></option>
    <option value="Wed"><bean:message key="cs_blackout.label.weekday_Wednesday" /></option>
    <option value="Thu"><bean:message key="cs_blackout.label.weekday_Thursday" /></option>
    <option value="Fri"><bean:message key="cs_blackout.label.weekday_Friday" /></option>
    <option value="Sat"><bean:message key="cs_blackout.label.weekday_Saturday" /></option>
    <option value="Sun"><bean:message key="cs_blackout.label.weekday_Sunday" /></option>
   </select>
 &nbsp;<input type="text" name="zWeekdayTimeFrom" value="<%= (request.getParameter("zWeekdayTimeFrom") == null ? "" : request.getParameter("zWeekdayTimeFrom")) %>" size="8" maxlength="8"/>
 </td>
 <td>&nbsp;</td>
</tr>
<tr>
 <td>&nbsp;</td>
 <td align="left">
  <div class="lbl"><bean:message key="cs_blackout.label.to.text" /></div>
 </td>
 <td>
 <select name="zWeekdayTo">
    <option value="Mon"><bean:message key="cs_blackout.label.weekday_Monday" /></option>
    <option value="Tue"><bean:message key="cs_blackout.label.weekday_Tuesday" /></option>
    <option value="Wed"><bean:message key="cs_blackout.label.weekday_Wednesday" /></option>
    <option value="Thu"><bean:message key="cs_blackout.label.weekday_Thursday" /></option>
    <option value="Fri"><bean:message key="cs_blackout.label.weekday_Friday" /></option>
    <option value="Sat"><bean:message key="cs_blackout.label.weekday_Saturday" /></option>
    <option value="Sun"><bean:message key="cs_blackout.label.weekday_Sunday" /></option>
 </select>

 &nbsp;<input type="text" name="zWeekdayTimeTo" value="<%= (request.getParameter("zWeekdayTimeTo") == null ? "" : request.getParameter("zWeekdayTimeTo")) %>" size="8" maxlength="8"/>
 </td>
<td>&nbsp;</td>
</tr>
<tr>
  <td colspan="2">&nbsp;&nbsp;&nbsp;</td>
  <td>
    <div class="lbl">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i><bean:message key="cs_blackout.label.timeFormat.text" /></i></div>
  </td>
  <td>&nbsp;</td>
</tr>
</table>

</td>
</tr>

<tr>
  <td colspan="2" height="14">
    <div style="font-size:1">&nbsp;</div>
  </td>
</tr>
</table>

</td>
</tr>
</table>

<table style="margin-left:285">
<tr>
 <td>
  <input name="addB" class="button" type="submit" value='<bean:message key="cs_blackout.button_add" />' onClick="return doAdd()"/>
  <input name="updateB" class="button" disabled="true" type="submit" value='<bean:message key="cs_blackout.button_update" />' onclick="return doUpdate()"/>
  <input name="newB" class="button" type="button" value='<bean:message key="cs_blackout.button_clear" />' onClick="doClear(); return false;"/>
 </td>
</tr>
<tr>
  <td>
    <div style="font-size:10px"><bean:message key="cs_blackout.timezone_info" /></div>
  </td>
</tr>
</table>

<div style="position:absolute;left:90px;top:300px"><input name="deleteB" class="button" disabled="true" type="submit" value='<bean:message key="cs_blackout.button_delete" />' onclick="return doDelete()"/></div>
</form>
<br/>
<lsw:ErrorMessage><lsw:True><div id="error" class="errortype">&nbsp;<bean:message key="process_server.error.desc" /><span class="errmsg">&nbsp;&nbsp;<lsw:Text/></span></div></lsw:True><lsw:False><div id="error"><br/></div></lsw:False></lsw:ErrorMessage>

</td>
</tr>
</table>

</body>
</html>
