<%@page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@page import="java.util.Collection"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Map"%>
<%@page import="java.math.BigDecimal"%>
<%@page import="javax.servlet.jsp.JspWriter"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.Process"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ProcessMonitorHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.FormatHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.AbstractProcessEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ProcessEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.bean.TableState"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.Tuples"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.TupleComparator"%>
<%@page import="org.apache.struts.util.MessageResources" %>
<%@page import="org.apache.struts.Globals" %>
<%@page import="org.apache.struts.taglib.TagUtils" %>
<%@ include file="/html/msgs-init.jsp" %>
<jsp:include page="header.jsp"/>
<%
ProcessMonitorHelper pmHelper = ProcessMonitorHelper.getInstance();
FormatHelper formatHelper = new FormatHelper();

if (!pmHelper.isEnabled()) {
    %>
	<div class="tablediv">
    <p class="message">
    <bean:message key="cs_processmonitor.process.processMonitorDisabled" />
    </p>
    </div>
</body>
</html>
	<%
    return;
}

Collection<Process> processes = pmHelper.getProcesses();

Map<BigDecimal, ProcessEntry> processEntryMap =	pmHelper.getProcessEntries(processes);
%>
	<div class="tablediv">
	<h2><bean:message key="cs_processmonitor.process.ativeProcessExcuting" /></h2>

	<%
	List<ProcessEntry> activeProcesses = Tuples.select(processEntryMap.values(),
			new ProcessMonitorHelper.ProcessByExecutionStatePredicate<ProcessEntry>(
					AbstractProcessEntry.STATE_ACTIVE), -1);

	TableState activeProcessesTable = (TableState)pageContext.getSession().getAttribute(
		"processes.activeProcessesTable");
	if (activeProcessesTable == null) {
		activeProcessesTable = new TableState();
		activeProcessesTable.setParamPrefix("activeProcesses.");
		activeProcessesTable.setSortFieldKey("lastEnterTimestamp");
		activeProcessesTable.setSortOrder(false);
		pageContext.getSession().setAttribute(
				"processes.activeProcessesTable", activeProcessesTable);
	}
	
	// Sorting should be applied before generation of table columns
	activeProcessesTable.applySortingFromParams(request.getParameterMap());

	String paramActiveProcessesPageIndex = request.getParameter(
			activeProcessesTable.getParamPrefix() + "pageIndex");
	int activeProcessesPageIndex = (paramActiveProcessesPageIndex != null ?
			Integer.parseInt(paramActiveProcessesPageIndex) : 0);
	int activeProcessesPageCount = pmHelper.getPageCount(activeProcesses,
			activeProcessesTable.getPageSize());
	%>

	<table class="sortable" id="activeProcesses">
	<thead>
		<tr>
			<th class="name sortheader" width="15%">
				<% renderTableSortHeaderCell(out, activeProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.processApp"), "processAppName"); %>
			</th>
			<th class="name sortheader" width="40%">
				<% renderTableSortHeaderCell(out, activeProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.processName"), "diagramName"); %>
			</th>
			<th class="date-time sortheader" width="20%">
				<% renderTableSortHeaderCell(out, activeProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.enterTime"), "lastEnterTimestamp"); %>
			</th>
			<th class="duration sortheader" width="15%">
				<% renderTableSortHeaderCell(out, activeProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.duration"), "duration"); %>
			</th>
			<th class="number sortheader" width="10%">
				<% renderTableSortHeaderCell(out, activeProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.totalSteps"), "workflowUnitTotalCount"); %>
			</th>
		</tr>
	</thead>			
	<tbody>
		<% if (activeProcesses.size() > 0) {
				List<ProcessEntry> records = new ArrayList<ProcessEntry>(activeProcesses);
				records = Tuples.sort(records, new TupleComparator(
						activeProcessesTable.getSortFieldKey(),
						activeProcessesTable.getSortOrder()));
				records = pmHelper.getPage(records,
						activeProcessesTable.getPageSize(), activeProcessesPageIndex);
				for (ProcessEntry p : records) { %>
				<tr>
					<td>
						<%=p.getProcessAppName()%>
					</td>
					<td>
						<a href="processDetail.lsw?id=<%=p.getProcessId()%>"><%=p.getDiagramName()%> (<%=p.getProcessId()%>)</a>
					</td>
					<td class="date-time">
						<%=formatHelper.formatTimestamp((Long)p.getLastEnterTimestamp())%>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)p.getDuration())%>										
					</td>
					<td class="number">
						<%=formatHelper.formatInteger(p.getWorkflowUnitTotalCount())%>
					</td>
				</tr>
			<% } %>
		<% } else { %>
			<tr>
				<td colspan="5"><bean:message key="cs_processmonitor.process.noActiveProcessesExecuting" /></td>
			</tr>
		<% } %>
	</tbody>
	</table>
	<% renderTablePaginationBar(out, activeProcessesTable,
			activeProcessesPageCount, activeProcessesPageIndex); %>
	</div>

	<div class="tablediv">
	<h2><bean:message key="cs_processmonitor.process.activeProcessNotExecuting" /></h2>

	<%
	List<ProcessEntry> inactiveProcesses = Tuples.select(processEntryMap.values(),
			new ProcessMonitorHelper.ProcessByExecutionStatePredicate<ProcessEntry>(
					AbstractProcessEntry.STATE_INACTIVE), -1);

	TableState inactiveProcessesTable = (TableState)pageContext.getSession().getAttribute(
		"processes.inactiveProcessesTable");
	if (inactiveProcessesTable == null) {
		inactiveProcessesTable = new TableState();
		inactiveProcessesTable.setParamPrefix("inactiveProcesses.");
		inactiveProcessesTable.setSortFieldKey("lastEnterTimestamp");
		inactiveProcessesTable.setSortOrder(false);
		pageContext.getSession().setAttribute(
				"processes.inactiveProcessesTable", inactiveProcessesTable);
	}
	// Sorting should be applied before generation of table columns
	inactiveProcessesTable.applySortingFromParams(request.getParameterMap());

	String paramInactiveProcessesPageIndex = request.getParameter(
			inactiveProcessesTable.getParamPrefix() + "pageIndex");
	int inactiveProcessesPageIndex = (paramInactiveProcessesPageIndex != null ?
			Integer.parseInt(paramInactiveProcessesPageIndex) : 0);
	int inactiveProcessesPageCount = pmHelper.getPageCount(inactiveProcesses,
			inactiveProcessesTable.getPageSize());
	%>

	<table  class="sortable" id="inactiveProcesses">
	<thead>
		<tr>
			<th class="name sortheader" width="15%">
				<% renderTableSortHeaderCell(out, inactiveProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.processApp"), "processAppName"); %>
			</th>
			<th class="name sortheader" width="25%">
				<% renderTableSortHeaderCell(out, inactiveProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.processName"), "diagramName"); %>
			</th>
			<th class="date-time sortheader" width="20%">
				<% renderTableSortHeaderCell(out, inactiveProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.lastEnterTime"), "lastEnterTimestamp"); %>
			</th>
			<th class="duration sortheader" width="15%">
				<% renderTableSortHeaderCell(out, inactiveProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.lastDuration"), "lastDuration"); %>
			</th>
			<th class="duration sortheader" width="15%">
				<% renderTableSortHeaderCell(out, inactiveProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.totalDuration"), "totalDuration"); %>
			</th>
			<th class="number sortheader" width="10%">
				<% renderTableSortHeaderCell(out, inactiveProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.totalSteps"), "workflowUnitTotalCount"); %>
			</th>
		</tr>
	</thead>
	<tbody>
		<% if (inactiveProcesses.size() > 0) {
			List<ProcessEntry> records = new ArrayList<ProcessEntry>(inactiveProcesses);
			records = Tuples.sort(records, new TupleComparator(
					inactiveProcessesTable.getSortFieldKey(),
					inactiveProcessesTable.getSortOrder()));
			records = pmHelper.getPage(records,
					inactiveProcessesTable.getPageSize(), inactiveProcessesPageIndex);
			for (ProcessEntry p : records) { %>
			<tr>
				<td>
					<%=p.getProcessAppName()%>
				</td>
				<td>
					<a href="processDetail.lsw?id=<%=p.getProcessId()%>"><%=p.getDiagramName()%> (<%=p.getProcessId()%>)</a>
				</td>
				<td class="date-time">
					<%=formatHelper.formatTimestamp((Long)p.getLastEnterTimestamp())%>
				</td>
				<td class="duration">
					<%=formatHelper.formatDuration((Long)p.getLastDuration())%>
				</td>
				<td class="duration">
					<%=formatHelper.formatDuration((Long)p.getTotalDuration())%>
				</td>
				<td class="number">
					<%=formatHelper.formatInteger(p.getWorkflowUnitTotalCount())%>
				</td>
			</tr>
			<% } %>
		<% } else { %>
			<tr>
				<td colspan="6"><bean:message key="cs_processmonitor.process.noActiveProvessNotExecuting" /></td>
			</tr>
		<% } %>
	</tbody>
	</table>
	<% renderTablePaginationBar(out, inactiveProcessesTable,
			inactiveProcessesPageCount, inactiveProcessesPageIndex); %>
	</div>

	<div class="tablediv">
	<h2><bean:message key="cs_processmonitor.process.completedProcesses" /></h2>

	<%
	List<ProcessEntry> completedProcesses = Tuples.select(processEntryMap.values(),
			new ProcessMonitorHelper.ProcessByExecutionStatePredicate<ProcessEntry>(
					AbstractProcessEntry.STATE_COMPLETED), -1);

	TableState completedProcessesTable = (TableState)pageContext.getSession().getAttribute(
		"processes.completedProcessesTable");
	if (completedProcessesTable == null) {
		completedProcessesTable = new TableState();
		completedProcessesTable.setParamPrefix("completedProcesses.");
		completedProcessesTable.setSortFieldKey("lastEnterTimestamp");
		completedProcessesTable.setSortOrder(false);
		pageContext.getSession().setAttribute(
				"processes.completedProcessesTable", completedProcessesTable);
	}
	// Sorting should be applied before generation of table columns
	completedProcessesTable.applySortingFromParams(request.getParameterMap());

	String paramCompletedProcessesPageIndex = request.getParameter(
			completedProcessesTable.getParamPrefix() + "pageIndex");
	int completedProcessesPageIndex = (paramCompletedProcessesPageIndex != null ?
			Integer.parseInt(paramCompletedProcessesPageIndex) : 0);
	int completedProcessesPageCount = pmHelper.getPageCount(completedProcesses,
			completedProcessesTable.getPageSize());
	%>

	<table  class="sortable" id="completedProcesses">
	<thead>
		<tr>
			<th class="name sortheader" width="15%">
				<% renderTableSortHeaderCell(out, completedProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.processApp"), "processAppName"); %>
			</th>
			<th class="name sortheader" width="25%">
				<% renderTableSortHeaderCell(out, completedProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.processName"), "diagramName"); %>
			</th>
			<th class="date-time sortheader" width="20%">
				<% renderTableSortHeaderCell(out, completedProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.lastEnterTime"), "lastEnterTimestamp"); %>
			</th>
			<th class="duration sortheader" width="15%">
				<% renderTableSortHeaderCell(out, completedProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.lastDuration"), "lastDuration"); %>
			</th>
			<th class="duration sortheader" width="15%">
				<% renderTableSortHeaderCell(out, completedProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.totalDuration"), "totalDuration"); %>
			</th>
			<th class="number sortheader" width="10%">
				<% renderTableSortHeaderCell(out, completedProcessesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.process.totalSteps"), "workflowUnitTotalCount"); %>
			</th>
		</tr>
	</thead>
	<tbody>
		<% if (completedProcesses.size() > 0) {
			List<ProcessEntry> records = new ArrayList<ProcessEntry>(completedProcesses);
			records = Tuples.sort(records, new TupleComparator(
					completedProcessesTable.getSortFieldKey(),
					completedProcessesTable.getSortOrder()));
			records = pmHelper.getPage(records,
					completedProcessesTable.getPageSize(), completedProcessesPageIndex);
			for (ProcessEntry p : records) { %>
			<tr>
				<td>
					<%=p.getProcessAppName()%>
				</td>
				<td>
					<a href="processDetail.lsw?id=<%=p.getProcessId()%>"><%=p.getDiagramName()%> (<%=p.getProcessId()%>)</a>
				</td>
				<td class="date-time">
					<%=formatHelper.formatTimestamp((Long)p.getLastEnterTimestamp())%>
				</td>
				<td class="duration">
					<%=formatHelper.formatDuration((Long)p.getLastDuration())%>
				</td>
				<td class="duration">
					<%=formatHelper.formatDuration((Long)p.getTotalDuration())%>
				</td>
				<td class="number">
					<%=formatHelper.formatInteger(p.getWorkflowUnitTotalCount())%>
				</td>
			</tr>
			<% } %>
		<% } else { %>
			<tr>
				<td colspan="6"><bean:message key="cs_processmonitor.process.noCompletedProcesses" /></td>
			</tr>
		<% } %>
	</tbody>
	</table>
	<% renderTablePaginationBar(out, completedProcessesTable,
			completedProcessesPageCount, completedProcessesPageIndex); %>
	</div>
</body>
</html>

<%!
private void renderTableSortHeaderCell(JspWriter out,
		TableState table, String text, String key) throws java.io.IOException {
	com.ibm.bpm.crconfig.BPMContextRootConfigService ctxRootService = com.ibm.bpm.crconfig.BPMContextRootConfigServiceFactory.getInstance().getContextRootConfigService();
	boolean order = table.getSortOrder();
	if (!key.equals(table.getSortFieldKey())) {
		order = true;
	} else {
		order = !order;
	}
	out.print("<a class='sortheader' href='processes.lsw?" +
			table.getParamPrefix() + "sort.key=" + key);
	out.print("&" +
			table.getParamPrefix() + "sort.order=" + order + "'>");
	out.print(text);
	if (key.equals(table.getSortFieldKey())) {
		out.print("<img src='"+ctxRootService.getContextRoot(com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_TEAMWORKS)+"/images/" +
				(table.getSortOrder() ? "sort_asc.gif" : "sort_desc.gif") + "' alt='' border='0'/>");
	}
	out.print("</a>");
}

private void renderTablePaginationBar(JspWriter out,
		TableState table, int pageCount, int pageIndex) throws java.io.IOException {
 	if (pageCount > 1) {
		out.println("<p>");
 		for (int i = 0; i < pageCount; i++) {
 			out.print("<a href='processes.lsw?" + table.getParamPrefix() + "pageIndex=" + i + "' ");
 			out.print("class='" + (i == pageIndex ? "curr-page-number" : "page-number") + "'>");
 			out.print(i + 1);
 			out.print("</a>");
 		}
		out.println("</p>");
 	}
}
%>