<%@page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@page import="java.util.Collection"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Map"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.Service"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ProcessMonitorHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.FormatHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.AbstractProcessEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ServiceEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.bean.TableState"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.Tuples"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.TupleComparator"%>
<%@page import="org.apache.struts.util.MessageResources" %>
<%@page import="org.apache.struts.Globals" %>
<%@page import="org.apache.struts.taglib.TagUtils" %>
<%@ include file="/html/msgs-init.jsp" %>
<jsp:include page="header.jsp"/>
<%
ProcessMonitorHelper pmHelper = ProcessMonitorHelper.getInstance();
FormatHelper formatHelper = new FormatHelper();

if (!pmHelper.isEnabled()) {
    %>
	<div class="tablediv">
    <p class="message">
    <bean:message key="cs_processmonitor.services.processMonitorDisabled" />
    </p>
    </div>
</body>
</html>
	<%
    return;
}

Collection<Service> services = pmHelper.getServices();

Map<String, ServiceEntry> serviceEntryMap =	pmHelper.getServiceEntries(services);
%>
	<div class="tablediv">
	<h2><bean:message key="cs_processmonitor.services.activeServicesExecuting" /></h2>
	
	<%
	List<ServiceEntry> activeServices = Tuples.select(serviceEntryMap.values(),
			new ProcessMonitorHelper.ProcessByExecutionStatePredicate<ServiceEntry>(
					AbstractProcessEntry.STATE_ACTIVE), -1);

	TableState activeServicesTable = (TableState)pageContext.getSession().getAttribute(
		"services.activeServicesTable");
	if (activeServicesTable == null) {
		activeServicesTable = new TableState();
		activeServicesTable.setParamPrefix("activeServices.");
		activeServicesTable.setSortFieldKey("lastEnterTimestamp");
		activeServicesTable.setSortOrder(false);
		pageContext.getSession().setAttribute(
				"services.activeServicesTable", activeServicesTable);
	}
	
	// Sorting should be applied before generation of table columns
	activeServicesTable.applySortingFromParams(request.getParameterMap());

	String paramActiveServicesPageIndex = request.getParameter(
			activeServicesTable.getParamPrefix() + "pageIndex");
	int activeServicesPageIndex = (paramActiveServicesPageIndex != null ?
			Integer.parseInt(paramActiveServicesPageIndex) : 0);
	int activeServicesPageCount = pmHelper.getPageCount(activeServices,
			activeServicesTable.getPageSize());
	%>
	
	<table class="sortable" id="activeServices">
	<thead>
		<tr>
			<th class="name sortheader" width="15%">
				<% 
				renderTableSortHeaderCell(out, activeServicesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.processApp"), "processAppName"); %>
			</th>
			<th class="name sortheader" width="40%">
				<% renderTableSortHeaderCell(out, activeServicesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.serviceName"), "diagramName"); %>
			</th>
			<th class="date-time sortheader" width="20%">
				<% renderTableSortHeaderCell(out, activeServicesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.enterTime"), "lastEnterTimestamp"); %>
			</th>
			<th class="duration sortheader" width="15%">
				<% renderTableSortHeaderCell(out, activeServicesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.duration"), "duration"); %>
			</th>
			<th class="number sortheader" width="10%">
				<% renderTableSortHeaderCell(out, activeServicesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.totalSteps"), "workflowUnitTotalCount"); %>
			</th>
		</tr>
	</thead>			
	<tbody>
		<% if (activeServices.size() > 0) {
			List<ServiceEntry> records = new ArrayList<ServiceEntry>(activeServices);
			records = Tuples.sort(records, new TupleComparator(
					activeServicesTable.getSortFieldKey(),
					activeServicesTable.getSortOrder()));
			records = pmHelper.getPage(records,
					activeServicesTable.getPageSize(), activeServicesPageIndex);
			for (ServiceEntry s : records) {
			%>
			<tr>
				<td>
					<%=s.getProcessAppName()%>
				</td>
				<td>
					<a href="serviceDetail.lsw?id=<%=s.getContextGuid()%>"><%=s.getDiagramName()%></a>
				</td>
				<td class="date-time">
					<%=formatHelper.formatTimestamp((Long)s.getLastEnterTimestamp())%>
				</td>
				<td class="duration">
					<%=formatHelper.formatDuration((Long)s.getDuration())%>										
				</td>
				<td class="number">
					<%=formatHelper.formatInteger(s.getWorkflowUnitTotalCount())%>
				</td>
			</tr>
			<% } %>
		<% } else { %>
			<tr>
				<td colspan="5"><bean:message key="cs_processmonitor.services.noActiveServices" /></td>
			</tr>
		<% } %>
	</tbody>
	</table>
	<% renderTablePaginationBar(out, activeServicesTable,
			activeServicesPageCount, activeServicesPageIndex); %>
	</div>
	
	<p/>			
	<div class="tablediv">
	<h2><bean:message key="cs_processmonitor.services.activeServicesNotExecuting" /></h2>

	<%
	List<ServiceEntry> inactiveServices = Tuples.select(serviceEntryMap.values(),
			new ProcessMonitorHelper.ProcessByExecutionStatePredicate<ServiceEntry>(
					AbstractProcessEntry.STATE_INACTIVE), -1);

	TableState inactiveServicesTable = (TableState)pageContext.getSession().getAttribute(
		"services.inactiveServicesTable");
	if (inactiveServicesTable == null) {
		inactiveServicesTable = new TableState();
		inactiveServicesTable.setParamPrefix("inactiveServices.");
		inactiveServicesTable.setSortFieldKey("lastEnterTimestamp");
		inactiveServicesTable.setSortOrder(false);
		pageContext.getSession().setAttribute(
				"services.inactiveServicesTable", inactiveServicesTable);
	}
	// Sorting should be applied before generation of table columns
	inactiveServicesTable.applySortingFromParams(request.getParameterMap());

	String paramInactiveServicesPageIndex = request.getParameter(
			inactiveServicesTable.getParamPrefix() + "pageIndex");
	int inactiveServicesPageIndex = (paramInactiveServicesPageIndex != null ?
			Integer.parseInt(paramInactiveServicesPageIndex) : 0);
	int inactiveServicesPageCount = pmHelper.getPageCount(inactiveServices,
			inactiveServicesTable.getPageSize());
	%>

	<table  class="sortable" id="inactiveServices">
	<thead>
		<tr>			
			<th class="name sortheader" width="15%">
				<% renderTableSortHeaderCell(out, inactiveServicesTable,
						TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.processApp"), "processAppName"); %>
			</th>
			<th class="name sortheader" width="25%">
				<% renderTableSortHeaderCell(out, inactiveServicesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.serviceName"), "diagramName"); %>
			</th>
			<th class="date-time sortheader" width="20%">
				<% renderTableSortHeaderCell(out, inactiveServicesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.lastEnterTime"), "lastEnterTimestamp"); %>
			</th>
			<th class="duration sortheader" width="15%">
				<% renderTableSortHeaderCell(out, inactiveServicesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.lastDuration"), "lastDuration"); %>
			</th>
			<th class="duration sortheader" width="15%">
				<% renderTableSortHeaderCell(out, inactiveServicesTable,
						TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.totalDuration"), "totalDuration"); %>
			</th>
			<th class="number sortheader" width="10%">
				<% renderTableSortHeaderCell(out, inactiveServicesTable,
				        TagUtils.getInstance().message(pageContext, null, Globals.LOCALE_KEY,"cs_processmonitor.services.totalSteps"), "workflowUnitTotalCount"); %>
			</th>
		</tr>
	</thead>
	<tbody>
		<% if (inactiveServices.size() > 0) {
			List<ServiceEntry> records = new ArrayList<ServiceEntry>(inactiveServices);
			records = Tuples.sort(records, new TupleComparator(
					inactiveServicesTable.getSortFieldKey(),
					inactiveServicesTable.getSortOrder()));
			records = pmHelper.getPage(records,
					inactiveServicesTable.getPageSize(), inactiveServicesPageIndex);
			for (ServiceEntry s : records) {
			%>
			<tr>
				<td>
					<%=s.getProcessAppName()%>
				</td>
				<td>
					<a href="serviceDetail.lsw?id=<%=s.getContextGuid()%>"><%=s.getDiagramName()%></a>
				</td>
				<td class="date-time">
					<%=formatHelper.formatTimestamp((Long)s.getLastEnterTimestamp())%>
				</td>
				<td class="duration">
					<%=formatHelper.formatDuration((Long)s.getLastDuration())%>
				</td>
				<td class="duration">
					<%=formatHelper.formatDuration((Long)s.getTotalDuration())%>
				</td>
				<td class="number">
					<%=formatHelper.formatInteger(s.getWorkflowUnitTotalCount())%>
				</td>
			</tr>
			<% } %>
		<% } else { %>
			<tr>
				<td colspan="6"><bean:message key="cs_processmonitor.services.noCompletedServices" /></td>
			</tr>
		<% } %>
	</tbody>
	</table>
	<% renderTablePaginationBar(out, inactiveServicesTable,
			inactiveServicesPageCount, inactiveServicesPageIndex); %>
	</div>
</body>
</html>

<%!
private void renderTableSortHeaderCell(JspWriter out,
		TableState table, String text, String key) throws java.io.IOException {
	com.ibm.bpm.crconfig.BPMContextRootConfigService ctxRootService = com.ibm.bpm.crconfig.BPMContextRootConfigServiceFactory.getInstance().getContextRootConfigService();
	boolean order = table.getSortOrder();
	if (!key.equals(table.getSortFieldKey())) {
		order = true;
	} else {
		order = !order;
	}
	out.print("<a class='sortheader' href='services.lsw?" +
			table.getParamPrefix() + "sort.key=" + key);
	out.print("&" +
			table.getParamPrefix() + "sort.order=" + order + "'>");
	out.print(text);
	if (key.equals(table.getSortFieldKey())) {
		out.print("<img src='"+ctxRootService.getContextRoot(com.ibm.bpm.crconfig.BPMContextRootConfigService.BPM_WARNAME_TEAMWORKS)+"/images/" +
				(table.getSortOrder() ? "sort_asc.gif" : "sort_desc.gif") + "' alt='' border='0'/>");
	}
	out.print("</a>");
}

private void renderTablePaginationBar(JspWriter out,
		TableState table, int pageCount, int pageIndex) throws java.io.IOException {
 	if (pageCount > 1) {
		out.println("<p>");
 		for (int i = 0; i < pageCount; i++) {
 			out.print("<a href='services.lsw?" + table.getParamPrefix() + "pageIndex=" + i + "' ");
 			out.print("class='" + (i == pageIndex ? "curr-page-number" : "page-number") + "'>");
 			out.print(i + 1);
 			out.print("</a>");
 		}
		out.println("</p>");
 	}
}
%>