<%@page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@page import="java.util.Collection"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Map"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.math.BigDecimal"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.Process"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.Service"%>
<%@page import="com.lombardisoftware.server.processmonitor.data.WorkflowUnit"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ProcessMonitorHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.FormatHelper"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.AbstractProcessEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ProcessEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.ServiceEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.jsp.WorkflowUnitEntry"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.Tuplable"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.Tuples"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.TupleComparator"%>
<%@page import="com.lombardisoftware.server.processmonitor.tuple.Predicate"%>
<%@ include file="/html/msgs-init.jsp" %>
<jsp:useBean id="summarySettings" scope="session"
	class="com.lombardisoftware.server.processmonitor.jsp.bean.SummarySettings"/>

<jsp:include page="header.jsp"/>
<%
ProcessMonitorHelper pmHelper = ProcessMonitorHelper.getInstance();
FormatHelper formatHelper = new FormatHelper(); 

if (!pmHelper.isEnabled()) {
    %>
	<div class="tablediv">
    <p class="message">
    <bean:message key="cs_processmonitor.summary.processMonitorDisabled" />
    </p>
    </div>
</body>
</html>
	<%
    return;
}

Collection<Process> processes = pmHelper.getProcesses();
Collection<Service> services = pmHelper.getServices();

Map<BigDecimal, ProcessEntry> processEntryMap =	pmHelper.getProcessEntries(processes);
Map<String, ServiceEntry> serviceEntryMap =	pmHelper.getServiceEntries(services);

List<ProcessEntry> activeProcesses = Tuples.select(processEntryMap.values(),
		new ProcessMonitorHelper.ProcessByExecutionStatePredicate<ProcessEntry>(
				AbstractProcessEntry.STATE_ACTIVE), -1);
List<ProcessEntry> allProcesses = new ArrayList<ProcessEntry>(processEntryMap.values());

List<ServiceEntry> activeServices = Tuples.select(serviceEntryMap.values(),
		new ProcessMonitorHelper.ProcessByExecutionStatePredicate<ServiceEntry>(
				AbstractProcessEntry.STATE_ACTIVE), -1);
List<ServiceEntry> allServices = new ArrayList<ServiceEntry>(serviceEntryMap.values());
%>
	<div id="summary" class="tablediv">
	<table class="name-value" width="275px">
		<tbody>
		<tr>
			<th width="85%"><bean:message key="cs_processmonitor.summary.activeProcessesExecuting" /></th>
			<td width="15%">
				<%=formatHelper.formatInteger(activeProcesses.size())%>
			</td>
		</tr>
		<tr>
			<th><bean:message key="cs_processmonitor.summary.activeServicesExecuting" /></th>
			<td>
				<%=formatHelper.formatInteger(activeServices.size())%>
			</td>
		</tr>
		</tbody>
	</table>
	</div>

	<div class="tablediv">
		<h2><bean:message key="cs_processmonitor.summary.mostExpensiveServices" /></h2>
		<table class="sortable">
			<thead>
				<tr>
					<th class="name" width="15%"><bean:message key="cs_processmonitor.summary.processApp" /></th>
					<th class="name" width="60%"><bean:message key="cs_processmonitor.summary.serviceName" /></th>
					<th class="duration" width="15%"><bean:message key="cs_processmonitor.summary.totalTime" /></th>
					<th class="number" width="10%"><bean:message key="cs_processmonitor.summary.totalSteps" /></th>
				</tr>
			</thead>
			<tbody>
			<% {
				if (allServices.size() > 0) {
					List<ServiceEntry> records = new ArrayList<ServiceEntry>(allServices);
					records = Tuples.sort(records, new TupleComparator("totalDuration", false));
					records = Tuples.select(records,
							new ProcessMonitorHelper.ExpensiveExecutionUnitPredicate<ServiceEntry>(
									summarySettings.getExpensiveServiceDurationMinThreshold()),
									summarySettings.getExpensiveServiceCount());
					for (ServiceEntry entry : records) {
						long totalDuration = entry.getTotalDuration();
				%>
				<tr class="<%=(totalDuration > summarySettings.getExpensiveServiceDurationMaxThreshold() ? "flag" : "normal")%>">
					<td class="name">
						<%=entry.getProcessAppName()%>
					</td>
					<td class="name">
						<a href="serviceDetail.lsw?id=<%=entry.getContextGuid()%>"><%=entry.getDiagramName()%></a>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)entry.getTotalDuration())%>
					</td>
					<td class="number">
						<%=formatHelper.formatInteger(entry.getWorkflowUnitTotalCount())%>
					</td>
				</tr>
				<%
					}
				} else {
				%>
					<tr>
						<td colspan="4">
							<bean:message key="cs_processmonitor.summary.noDataAvailable" />
						</td>
					</tr>
				<%
				}
			} %>
			</tbody>
		</table>
	</div>

	<div class="tablediv">
		<h2><bean:message key="cs_processmonitor.summary.mostExpensiveProcesses" /></h2>
		<table class="sortable">
			<thead>
				<tr>					
					<th class="name" width="15%"><bean:message key="cs_processmonitor.summary.processApp" /></th>
					<th class="name" width="60%"><bean:message key="cs_processmonitor.summary.processName" /></th>
					<th class="duration" width="15%"><bean:message key="cs_processmonitor.summary.totalTime" /></th>
					<th class="number" width="10%"><bean:message key="cs_processmonitor.summary.totalSteps" /></th>
				</tr>
			</thead>
			<tbody>
			<% {
				if (allProcesses.size() > 0) {
					List<ProcessEntry> records = new ArrayList<ProcessEntry>(allProcesses);
					records = Tuples.sort(records, new TupleComparator("totalDuration", false));
					records = Tuples.select(records,
							new ProcessMonitorHelper.ExpensiveExecutionUnitPredicate<ProcessEntry>(
									summarySettings.getExpensiveProcessDurationMinThreshold()),
									summarySettings.getExpensiveProcessCount());
					for (ProcessEntry entry : records) {
						long totalDuration = entry.getTotalDuration();
				%>
				<tr class="<%=(totalDuration > summarySettings.getExpensiveProcessDurationMaxThreshold() ? "flag" : "normal")%>">
					<td class="name">
						<%=entry.getProcessAppName()%>
					</td>
					<td class="name">
						<a href="processDetail.lsw?id=<%=entry.getProcessId()%>"><%=entry.getDiagramName()%></a>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)entry.getTotalDuration())%>
					</td>
					<td class="number">
						<%=formatHelper.formatInteger(entry.getWorkflowUnitTotalCount())%>
					</td>
				</tr>
				<%
					}
				} else {
				%>
					<tr>
						<td colspan="4">
							<bean:message key="cs_processmonitor.summary.noDataAvailable" />
						</td>
					</tr>
				<%
				}
			} %>
			</tbody>
		</table>
	</div>

	<div class="tablediv">
		<h2><bean:message key="cs_processmonitor.summary.mostExpensiveServiceSteps" /></h2>
		<table class="sortable">
			<thead>
				<tr>
					<th class="name" width="15%"><bean:message key="cs_processmonitor.summary.processApp" /></th>
					<th class="name" width="20%"><bean:message key="cs_processmonitor.summary.serviceName" /></th>
					<th class="name" width="15%"><bean:message key="cs_processmonitor.summary.sub_serviceName" /></th>
					<th class="name" width="20"><bean:message key="cs_processmonitor.summary.stepName" /></th>
					<th class="duration" width="15%"><bean:message key="cs_processmonitor.summary.totalTime" /></th>
					<th class="number" width="15%"><bean:message key="cs_processmonitor.summary.totalInstances" /></th>
				</tr>
			</thead>
			<tbody>
			<% {
				if (allServices.size() > 0) {
					List<WorkflowUnitEntry<ServiceEntry>> records =
						pmHelper.getServiceWorkflowUnitEntries(allServices);
					records = Tuples.sort(records, new TupleComparator("totalDuration", false));
					records = Tuples.select(records,
							new ProcessMonitorHelper.ExpensiveExecutionUnitPredicate<WorkflowUnitEntry<ServiceEntry>>(
									summarySettings.getExpensiveServiceWorkflowUnitDurationMinThreshold()),
									summarySettings.getExpensiveServiceWorkflowUnitCount());
					for (WorkflowUnitEntry<ServiceEntry> entry : records) {
						ServiceEntry serviceEntry = entry.getParentEntry();
						long totalDuration = entry.getTotalDuration();
				%>
				<tr class="<%=(totalDuration > summarySettings.getExpensiveServiceWorkflowUnitDurationMaxThreshold() ? "flag" : "normal")%>">
					<td class="name">
						<%=entry.getProcessAppName()%>
					</td>
					<td class="name">
						<a href="serviceDetail.lsw?id=<%=serviceEntry.getContextGuid()%>"><%=serviceEntry.getDiagramName()%></a>
					</td>
					<td class="name">
						<%=(!serviceEntry.getDiagramId().equals(entry.getDiagramId())) ? entry.getDiagramName() : ""%>
					</td>
					<td class="name">
						<%=entry.getName()%>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)entry.getTotalDuration())%>
					</td>
					<td class="number">
						<%=formatHelper.formatInteger(entry.getCount())%>
					</td>
				</tr>
				<%
					}
				} else {
				%>
					<tr>
						<td colspan="6">
							<bean:message key="cs_processmonitor.summary.noDataAvailable" />
						</td>
					</tr>
				<%
				}
			} %>
			</tbody>
		</table>
	</div>

	<div class="tablediv">
		<h2><bean:message key="cs_processmonitor.summary.mostExpensiveProcessSteps" /></h2>
		<table class="sortable">
			<thead>
				<tr>
					<th class="name" width="15%"><bean:message key="cs_processmonitor.summary.processApp" /></th>
					<th class="name" width="20%"><bean:message key="cs_processmonitor.summary.processName" /></th>
					<th class="name" width="15%"><bean:message key="cs_processmonitor.summary.sub_processName" /></th>
					<th class="name" width="20%"><bean:message key="cs_processmonitor.summary.stepName" /></th>
					<th class="duration" width="15%"><bean:message key="cs_processmonitor.summary.totalTime" /></th>
					<th class="number" width="15%"><bean:message key="cs_processmonitor.summary.totalInstances" /></th>
				</tr>
			</thead>
			<tbody>
			<% {
				if (allProcesses.size() > 0) {
					List<WorkflowUnitEntry<ProcessEntry>> records =
						pmHelper.getProcessWorkflowUnitEntries(allProcesses);
					records = Tuples.sort(records, new TupleComparator("totalDuration", false));
					records = Tuples.select(records,
							new ProcessMonitorHelper.ExpensiveExecutionUnitPredicate<WorkflowUnitEntry<ProcessEntry>>(
									summarySettings.getExpensiveProcessWorkflowUnitDurationMinThreshold()),
									summarySettings.getExpensiveProcessWorkflowUnitCount());
					for (WorkflowUnitEntry<ProcessEntry> entry : records) {
						ProcessEntry processEntry = entry.getParentEntry();
						long totalDuration = entry.getTotalDuration();
				%>
				<tr class="<%=(totalDuration > summarySettings.getExpensiveProcessWorkflowUnitDurationMaxThreshold() ? "flag" : "normal")%>">
					<td class="name">
						<%=entry.getProcessAppName()%>
					</td>
					<td class="name">
						<a href="processDetail.lsw?id=<%=processEntry.getProcessId()%>"><%=processEntry.getDiagramName()%></a>
					</td>
					<td class="name">
						<%=(!processEntry.getDiagramId().getId().equals(entry.getDiagramId().getId())) ? entry.getDiagramName() : ""%>
					</td>
					<td class="name">
						<%=entry.getName()%>
					</td>
					<td class="duration">
						<%=formatHelper.formatDuration((Long)entry.getTotalDuration())%>
					</td>
					<td class="number">
						<%=formatHelper.formatInteger(entry.getCount())%>
					</td>
				</tr>
				<%
					}
				} else {
				%>
					<tr>
						<td colspan="6">
							<bean:message key="cs_processmonitor.summary.noDataAvailable" />
						</td>
					</tr>
				<%
				}
			} %>
			</tbody>
		</table>
	</div>
	
</body>
</html>
